function [centroids, indices] = kMeans(X, initial_centroids, max_iters, plot_progress)

% Set default value for plot progress
if nargin < 4 
    plot_progress = false;
end

[nrPoints, nrDims] = size(X);
nr_clusters = size(initial_centroids, 1);
centroids = initial_centroids;
indices = zeros(nrPoints, 1);

for i=1:max_iters
    fprintf('K-Means iteration %d/%d...\n', i, max_iters);
    previous_indices = indices;
    indices = NearestCentroids(X, centroids);
    if isempty(find(indices ~= previous_indices))
        %no indices have changed, we are done!
        break; %<- 'break' ends the for loop 
    end
    if plot_progress
        PlotDataAndCentroids(X, centroids, indices, nr_clusters);
        fprintf('Press enter to continue.\n');
        pause;
    end
    centroids = UpdateCentroids(X, indices, nr_clusters);
end

return
